<template>
  <v-form ref="form" v-model="valid" lazy-validation @submit="validateLocation">
    <!-- :LocateName.sync="obj.locateName"
      :Latitude.sync="obj.latitude"
      :Longtitude.sync="obj.longtitude"
      :SubDistrict.sync="obj.subDistrict"
      :District.sync="obj.district"
      :PostalCode.sync="obj.postalCode"
      :Province.sync="obj.province" -->
    <InputLocation v-model="obj" :disabled="false" />
    <div class="my-1" align="center">
      <v-btn type="submit" color="primary" depressed medium>ยืนยันข้อมูล</v-btn>
    </div>
    <DialogConfirm :dialog="dialogConfirm" :title="objDialog.title">
      <template v-slot:confirm>
        <v-btn
          color="success"
          text
          :disabled="loading"
          :loading="loading"
          @click="confirm"
        >
          ใช่
        </v-btn>
      </template>
      <template v-slot:close>
        <v-btn
          color="error"
          text
          :disabled="loading"
          @click="dialogConfirm = false"
        >
          ไม่ใช่
        </v-btn>
      </template>
    </DialogConfirm>
  </v-form>
</template>

<script>
import InputLocation from "./InputLocation";
import DialogConfirm from "../dialog/DialogConfirm";
export default {
  components: { InputLocation, DialogConfirm },
  props: ["obj"],
  data() {
    return {
      valid: true,
      loading: false,
      dialogConfirm: false,
      objDialog: {},
    };
  },
  methods: {
    validateLocation(e) {
      e.preventDefault();
      const formValid = this.$refs.form.validate();
      if (formValid === true) {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการเพิ่มพื้นที่หรือไม่";
      }
    },
    async confirm() {
      this.loading = true;
      const param = {
        LocateName: this.obj.locateName,
        Latitude: this.obj.latitude,
        Longtitude: this.obj.longtitude,
        SubDistrict: this.obj.subDistrict,
        District: this.obj.district,
        PostalCode: this.obj.postalCode,
        Province: this.obj.province,
        accountId: localStorage.getItem("accountId"),
      };
      await this.$store.dispatch("locate/addLocation", param);
      if (this.$store.getters["locate/error"] != true) {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "เพิ่มพื้นที่สำเร็จ",
          color: "success",
          timeout: 5000,
        });
        this.loading = false;
        this.dialogConfirm = false;
        this.$router.replace({ name: "location-list" });
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "เพิ่มพื้นที่ไม่สำเร็จ",
          color: "red",
          timeout: 4000,
        });
        this.dialogConfirm = false;
        this.loading = false;
      }
    },
  },
};
</script>

<style>
</style>